import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { GoodsDescription, GoodsDescriptionParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商品描述表
 */
export async function pageGoodsDescription(params: GoodsDescriptionParam) {
  const res = await request.get<ApiResult<PageResult<GoodsDescription>>>(
    MODULES_API_URL + '/shop/goods-description/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品描述表列表
 */
export async function listGoodsDescription(params?: GoodsDescriptionParam) {
  const res = await request.get<ApiResult<GoodsDescription[]>>(
    MODULES_API_URL + '/shop/goods-description',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品描述表
 */
export async function addGoodsDescription(data: GoodsDescription) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-description',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品描述表
 */
export async function updateGoodsDescription(data: GoodsDescription) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-description',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品描述表
 */
export async function removeGoodsDescription(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-description/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品描述表
 */
export async function removeBatchGoodsDescription(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-description/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品描述表
 */
export async function getGoodsDescription(id: number) {
  const res = await request.get<ApiResult<GoodsDescription>>(
    MODULES_API_URL + '/shop/goods-description/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
